import { Data, Delta } from "./types";
declare type Params<Domain> = {
    commitTransaction: <K extends keyof Domain>(kind: K, id: string, delta: (prev: Domain[K]) => Domain[K]) => Promise<void>;
    onChangePendingTransactionCount: () => void;
    onError: (error: Error) => void;
    onRerenderKind: <K extends keyof Domain>(kind: K, id: string) => void;
    optimisticUIEnabled: () => boolean;
};
export declare function optimisticUi<Domain>(params: Params<Domain>): {
    pendingTransactionCount: () => number;
    update: <K extends keyof Domain>(kind: K, id: string, delta: Delta<Domain, K>) => void;
    withPendingTransactions: (data: Data<Domain>) => Data<Domain>;
};
export {};
