"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function makeAuthQueue(params) {
    const { onTerminate } = params;
    let currentPromise = Promise.resolve(undefined);
    const waitingCalls = [];
    return {
        details: () => __awaiter(this, void 0, void 0, function* () {
            const details = yield currentPromise;
            if (details)
                return details;
            if (waitingCalls.length > 100) {
                console.warn("Cache Size exceeded maximum allowed length");
                onTerminate();
                return new Promise(() => { });
            }
            return new Promise(resolve => waitingCalls.push(resolve));
        }),
        newAuthIncoming: (p) => __awaiter(this, void 0, void 0, function* () {
            currentPromise = p;
            const details = yield p;
            if (!details || currentPromise !== p)
                return;
            waitingCalls.forEach(f => f(details));
            waitingCalls.splice(0);
        })
    };
}
exports.makeAuthQueue = makeAuthQueue;
//# sourceMappingURL=authQueue.js.map