/// <reference types="node" />
import { Server as HttpServer } from "http";
import { Server as WsServer } from "ws";
import { Serialization } from "../serialization";
export declare const stringy: ({ kind, id }: K) => string;
export declare type K = {
    id: string;
    kind: string;
};
export declare type KV = K & {
    value: ValueContainer;
};
export declare type Params<AuthDetails> = {
    auth?: {
        canRead: (params: {
            auth: AuthDetails;
            kind: string;
            id: string;
        }) => boolean;
        canWrite: (params: {
            auth: AuthDetails;
            kind: string;
            id: string;
        }) => boolean;
        parseToken: (token: string, params: {
            close: () => void;
        }) => Promise<AuthDetails>;
    };
    onChangeData: (params: {
        kind: string;
        lastSeenRevision: string;
        id: string;
        close: () => void;
        value: unknown;
    }) => Promise<{
        newValue: unknown;
        newRevision: string;
    } | "conflict">;
    onRequestData: (params: {
        kind: string;
        id: string;
        close: () => void;
        send: (v: ValueContainer) => void;
    }) => void;
    serialization?: Serialization;
} & ({
    port: number;
    server?: undefined;
    _ws?: undefined;
} | {
    port?: undefined;
    server: HttpServer;
    _ws?: undefined;
} | {
    port?: undefined;
    server?: undefined;
    _ws?: WsServer;
});
export declare type ValueContainer = {
    revision: string;
    value: unknown;
};
