"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = require(".");
function testWsAdapter() {
    const sentMessages = [];
    const partialSocket = {
        send: data => {
            sentMessages.push(JSON.parse(String(data)));
        }
    };
    const socket = partialSocket;
    const sock = socket;
    const wsp = _1.makeWsProtocolAdapter({
        url: "",
        _socket: socket
    });
    const adapter = wsp.adapter({
        onChange: () => { },
        onConnectivityChange: () => { },
        onError: () => { },
        onPushResult: () => { }
    });
    return {
        adapter,
        auth: wsp.auth,
        disconnect: () => {
            socket.onclose({});
            sock.readyState = 0;
        },
        connect: () => {
            socket.onopen({});
            sock.readyState = 1;
        },
        sentMessages
    };
}
exports.default = testWsAdapter;
//# sourceMappingURL=testWsAdapter.js.map