/// <reference types="react" />
import { CreateParams, Data } from "../../core";
import { ReactType } from "./types";
declare type Configuration<Domain> = {
    data: Data<Domain>;
    React: ReactType;
};
export declare function configure<Domain>(configuration: Configuration<Domain>): {
    create: (params: CreateParams<Domain>) => {
        db: import("../../core").FullDB<Domain>;
        withDB: (children: import("react").ReactNode) => import("react").ComponentElement<{
            value: import("../../core").FullDB<Domain>;
            children: import("react").ReactNode;
        }, import("react").Component<{
            value: import("../../core").FullDB<Domain>;
            children: import("react").ReactNode;
        }, any, any>>;
    };
    SemiControlledInput: (props: import("react").InputHTMLAttributes<HTMLInputElement>) => import("react").DetailedReactHTMLElement<import("react").InputHTMLAttributes<HTMLInputElement>, HTMLInputElement>;
    useTryDB: () => "missing-provider" | import("../../core").FullDB<Domain>;
    useConnectivity: () => import("../..").Connectivity;
    useData: <K extends keyof Domain>(kind: K, id: string) => ["loading" | Domain[K], import("./hooks").Updater<Domain[K]>];
    useOncillaDebug: () => [import("../../core").DebugConfig, (partial: Partial<import("../../core").DebugConfig>) => void];
    usePendingChanges: () => number | false;
};
export {};
