"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("../../core");
const context_1 = require("./context");
const hooks_1 = require("./hooks");
const inputs_1 = require("./inputs");
function configure(configuration) {
    const { data, React } = configuration;
    const { Provider, useTryDB } = context_1.createContext({ React });
    const hooks = hooks_1.makeHooks({ useTryDB, React });
    return Object.assign({}, hooks, { create: (params) => {
            const db = core_1.create(Object.assign({}, params, { initialData: data }));
            const withDB = (children) => React.createElement(Provider, { value: db, children: children });
            return { db, withDB };
        }, SemiControlledInput: inputs_1.makeSemiControlledInput(React), useTryDB });
}
exports.configure = configure;
//# sourceMappingURL=configure.js.map