import { DebugConfig, FullDB } from "../../core";
import { ReactType } from "./types";
declare type UpdaterInternal<T> = (options: {}, delta: (prev: T) => T) => void;
export interface Updater<T> extends UpdaterInternal<T> {
    (delta: (prev: T) => T): void;
}
export declare function makeHooks<Domain>(params: {
    React: ReactType;
    useTryDB: () => FullDB<Domain> | "missing-provider";
}): {
    useConnectivity: () => import("../..").Connectivity;
    useData: <K extends keyof Domain>(kind: K, id: string) => [Domain[K] | "loading", Updater<Domain[K]>];
    useOncillaDebug: () => [DebugConfig, (partial: Partial<DebugConfig>) => void];
    usePendingChanges: () => number | false;
};
export {};
