import React from "react";
export declare function makeReactMock(): {
    _setContextValue: (val: any) => void;
    createFactory<T extends HTMLElement>(type: "object" | "big" | "link" | "small" | "sub" | "sup" | "input" | "progress" | "select" | "time" | "menu" | "dialog" | "data" | "a" | "abbr" | "address" | "area" | "article" | "aside" | "audio" | "b" | "base" | "bdi" | "bdo" | "blockquote" | "body" | "br" | "button" | "canvas" | "caption" | "cite" | "code" | "col" | "colgroup" | "datalist" | "dd" | "del" | "details" | "dfn" | "div" | "dl" | "dt" | "em" | "embed" | "fieldset" | "figcaption" | "figure" | "footer" | "form" | "h1" | "h2" | "h3" | "h4" | "h5" | "h6" | "head" | "header" | "hgroup" | "hr" | "html" | "i" | "iframe" | "img" | "ins" | "kbd" | "keygen" | "label" | "legend" | "li" | "main" | "map" | "mark" | "menuitem" | "meta" | "meter" | "nav" | "noscript" | "ol" | "optgroup" | "option" | "output" | "p" | "param" | "picture" | "pre" | "q" | "rp" | "rt" | "ruby" | "s" | "samp" | "script" | "section" | "source" | "span" | "strong" | "style" | "summary" | "table" | "tbody" | "td" | "textarea" | "tfoot" | "th" | "thead" | "title" | "tr" | "track" | "u" | "ul" | "var" | "video" | "wbr" | "webview"): React.HTMLFactory<T>;
    createFactory(type: "symbol" | "text" | "animate" | "circle" | "clipPath" | "defs" | "desc" | "ellipse" | "feBlend" | "feColorMatrix" | "feComponentTransfer" | "feComposite" | "feConvolveMatrix" | "feDiffuseLighting" | "feDisplacementMap" | "feDistantLight" | "feDropShadow" | "feFlood" | "feFuncA" | "feFuncB" | "feFuncG" | "feFuncR" | "feGaussianBlur" | "feImage" | "feMerge" | "feMergeNode" | "feMorphology" | "feOffset" | "fePointLight" | "feSpecularLighting" | "feSpotLight" | "feTile" | "feTurbulence" | "filter" | "foreignObject" | "g" | "image" | "line" | "linearGradient" | "marker" | "mask" | "metadata" | "path" | "pattern" | "polygon" | "polyline" | "radialGradient" | "rect" | "stop" | "svg" | "switch" | "textPath" | "tspan" | "use" | "view"): React.SVGFactory;
    createFactory<P extends React.DOMAttributes<T>, T extends Element>(type: string): React.DOMFactory<P, T>;
    createFactory<P>(type: React.FunctionComponent<P>): React.FunctionComponentFactory<P>;
    createFactory<P>(type: React.ClassType<P, React.ClassicComponent<P, any>, React.ClassicComponentClass<P>>): React.ComponentFactory<P, React.ClassicComponent<P, any>>;
    createFactory<P, T extends React.Component<P, any, any>, C extends React.ComponentClass<P, any>>(type: React.ClassType<P, T, C>): React.ComponentFactory<P, T>;
    createFactory<P>(type: React.ComponentClass<P, any>): React.Factory<P>;
    createElement(type: "input", props?: (React.InputHTMLAttributes<HTMLInputElement> & React.ClassAttributes<HTMLInputElement>) | null | undefined, ...children: React.ReactNode[]): React.DetailedReactHTMLElement<React.InputHTMLAttributes<HTMLInputElement>, HTMLInputElement>;
    createElement<P extends React.HTMLAttributes<T>, T extends HTMLElement>(type: "object" | "big" | "link" | "small" | "sub" | "sup" | "input" | "progress" | "select" | "time" | "menu" | "dialog" | "data" | "a" | "abbr" | "address" | "area" | "article" | "aside" | "audio" | "b" | "base" | "bdi" | "bdo" | "blockquote" | "body" | "br" | "button" | "canvas" | "caption" | "cite" | "code" | "col" | "colgroup" | "datalist" | "dd" | "del" | "details" | "dfn" | "div" | "dl" | "dt" | "em" | "embed" | "fieldset" | "figcaption" | "figure" | "footer" | "form" | "h1" | "h2" | "h3" | "h4" | "h5" | "h6" | "head" | "header" | "hgroup" | "hr" | "html" | "i" | "iframe" | "img" | "ins" | "kbd" | "keygen" | "label" | "legend" | "li" | "main" | "map" | "mark" | "menuitem" | "meta" | "meter" | "nav" | "noscript" | "ol" | "optgroup" | "option" | "output" | "p" | "param" | "picture" | "pre" | "q" | "rp" | "rt" | "ruby" | "s" | "samp" | "script" | "section" | "source" | "span" | "strong" | "style" | "summary" | "table" | "tbody" | "td" | "textarea" | "tfoot" | "th" | "thead" | "title" | "tr" | "track" | "u" | "ul" | "var" | "video" | "wbr" | "webview", props?: (React.ClassAttributes<T> & P) | null | undefined, ...children: React.ReactNode[]): React.DetailedReactHTMLElement<P, T>;
    createElement<P extends React.SVGAttributes<T>, T extends SVGElement>(type: "symbol" | "text" | "animate" | "circle" | "clipPath" | "defs" | "desc" | "ellipse" | "feBlend" | "feColorMatrix" | "feComponentTransfer" | "feComposite" | "feConvolveMatrix" | "feDiffuseLighting" | "feDisplacementMap" | "feDistantLight" | "feDropShadow" | "feFlood" | "feFuncA" | "feFuncB" | "feFuncG" | "feFuncR" | "feGaussianBlur" | "feImage" | "feMerge" | "feMergeNode" | "feMorphology" | "feOffset" | "fePointLight" | "feSpecularLighting" | "feSpotLight" | "feTile" | "feTurbulence" | "filter" | "foreignObject" | "g" | "image" | "line" | "linearGradient" | "marker" | "mask" | "metadata" | "path" | "pattern" | "polygon" | "polyline" | "radialGradient" | "rect" | "stop" | "svg" | "switch" | "textPath" | "tspan" | "use" | "view", props?: (React.ClassAttributes<T> & P) | null | undefined, ...children: React.ReactNode[]): React.ReactSVGElement;
    createElement<P extends React.DOMAttributes<T>, T extends Element>(type: string, props?: (React.ClassAttributes<T> & P) | null | undefined, ...children: React.ReactNode[]): React.DOMElement<P, T>;
    createElement<P extends {}>(type: React.FunctionComponent<P>, props?: (React.Attributes & P) | null | undefined, ...children: React.ReactNode[]): React.FunctionComponentElement<P>;
    createElement<P extends {}>(type: React.ClassType<P, React.ClassicComponent<P, any>, React.ClassicComponentClass<P>>, props?: (React.ClassAttributes<React.ClassicComponent<P, any>> & P) | null | undefined, ...children: React.ReactNode[]): React.ComponentElement<P, React.ClassicComponent<P, any>>;
    createElement<P extends {}, T extends React.Component<P, any, any>, C extends React.ComponentClass<P, any>>(type: React.ClassType<P, T, C>, props?: (React.ClassAttributes<T> & P) | null | undefined, ...children: React.ReactNode[]): React.ComponentElement<P, T>;
    createElement<P extends {}>(type: string | React.FunctionComponent<P> | React.ComponentClass<P, any>, props?: (React.Attributes & P) | null | undefined, ...children: React.ReactNode[]): React.ReactElement<P, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)>;
    cloneElement<P extends React.HTMLAttributes<T>, T extends HTMLElement>(element: React.DetailedReactHTMLElement<P, T>, props?: P | undefined, ...children: React.ReactNode[]): React.DetailedReactHTMLElement<P, T>;
    cloneElement<P extends React.HTMLAttributes<T>, T extends HTMLElement>(element: React.ReactHTMLElement<T>, props?: P | undefined, ...children: React.ReactNode[]): React.ReactHTMLElement<T>;
    cloneElement<P extends React.SVGAttributes<T>, T extends SVGElement>(element: React.ReactSVGElement, props?: P | undefined, ...children: React.ReactNode[]): React.ReactSVGElement;
    cloneElement<P extends React.DOMAttributes<T>, T extends Element>(element: React.DOMElement<P, T>, props?: (React.DOMAttributes<T> & P) | undefined, ...children: React.ReactNode[]): React.DOMElement<P, T>;
    cloneElement<P>(element: React.FunctionComponentElement<P>, props?: (Partial<P> & React.Attributes) | undefined, ...children: React.ReactNode[]): React.FunctionComponentElement<P>;
    cloneElement<P, T extends React.Component<P, any, any>>(element: React.ComponentElement<P, T>, props?: (Partial<P> & React.ClassAttributes<T>) | undefined, ...children: React.ReactNode[]): React.ComponentElement<P, T>;
    cloneElement<P>(element: React.ReactElement<P, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)>, props?: (Partial<P> & React.Attributes) | undefined, ...children: React.ReactNode[]): React.ReactElement<P, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)>;
    createContext<T>(defaultValue: T, calculateChangedBits?: ((prev: T, next: T) => number) | undefined): React.Context<T>;
    isValidElement<P>(object: {} | null | undefined): object is React.ReactElement<P, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)>;
    createRef<T>(): React.RefObject<T>;
    forwardRef<T, P = {}>(Component: React.RefForwardingComponent<T, P>): React.ForwardRefExoticComponent<React.PropsWithoutRef<P> & React.RefAttributes<T>>;
    memo<P extends object>(Component: React.FunctionComponent<P>, propsAreEqual?: ((prevProps: Readonly<React.PropsWithChildren<P>>, nextProps: Readonly<React.PropsWithChildren<P>>) => boolean) | undefined): React.NamedExoticComponent<P>;
    memo<T extends React.ComponentType<any>>(Component: T, propsAreEqual?: ((prevProps: Readonly<React.ComponentProps<T>>, nextProps: Readonly<React.ComponentProps<T>>) => boolean) | undefined): React.MemoExoticComponent<T>;
    lazy<T extends React.ComponentType<any>>(factory: () => Promise<{
        default: T;
    }>): React.LazyExoticComponent<T>;
    useContext<T>(context: React.Context<T>): T;
    useState<S>(initialState: S | (() => S)): [S, React.Dispatch<React.SetStateAction<S>>];
    useState<S = undefined>(): [S | undefined, React.Dispatch<React.SetStateAction<S | undefined>>];
    useReducer<R extends React.Reducer<any, any>, I>(reducer: R, initializerArg: I & React.ReducerState<R>, initializer: (arg: I & React.ReducerState<R>) => React.ReducerState<R>): [React.ReducerState<R>, React.Dispatch<React.ReducerAction<R>>];
    useReducer<R extends React.Reducer<any, any>, I>(reducer: R, initializerArg: I, initializer: (arg: I) => React.ReducerState<R>): [React.ReducerState<R>, React.Dispatch<React.ReducerAction<R>>];
    useReducer<R extends React.Reducer<any, any>>(reducer: R, initialState: React.ReducerState<R>, initializer?: undefined): [React.ReducerState<R>, React.Dispatch<React.ReducerAction<R>>];
    useRef<T>(initialValue: T): React.MutableRefObject<T>;
    useRef<T>(initialValue: T | null): React.RefObject<T>;
    useRef<T = undefined>(): React.MutableRefObject<T | undefined>;
    useLayoutEffect(effect: React.EffectCallback, deps?: ReadonlyArray<any> | undefined): void;
    useEffect(effect: React.EffectCallback, deps?: ReadonlyArray<any> | undefined): void;
    useImperativeHandle<T, R extends T>(ref: ((instance: T | null) => void) | React.RefObject<T> | null | undefined, init: () => R, deps?: ReadonlyArray<any> | undefined): void;
    useCallback<T extends (...args: any[]) => any>(callback: T, deps: ReadonlyArray<any>): T;
    useMemo<T>(factory: () => T, deps: ReadonlyArray<any> | undefined): T;
    useDebugValue<T>(value: T, format?: ((value: T) => any) | undefined): void;
    Children: React.ReactChildren;
    Fragment: React.ExoticComponent<{
        children?: React.ReactNode;
    }>;
    StrictMode: React.ExoticComponent<{
        children?: React.ReactNode;
    }>;
    Suspense: React.ExoticComponent<React.SuspenseProps>;
    version: string;
    unstable_Profiler: React.ExoticComponent<React.ProfilerProps>;
    Component: typeof React.Component;
    PureComponent: typeof React.PureComponent;
};
export { makeWindowMock, networkMock } from "../mocks";
